# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class IPrimitiveType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'value_as_string': 'str',
        'value': 'object',
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'empty': 'bool'
    }

    attribute_map = {
        'value_as_string': 'valueAsString',
        'value': 'value',
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'empty': 'empty'
    }

    def __init__(self, value_as_string=None, value=None, format_comments_pre=None, format_comments_post=None, empty=None):  # noqa: E501
        """IPrimitiveType - a model defined in Swagger"""  # noqa: E501

        self._value_as_string = None
        self._value = None
        self._format_comments_pre = None
        self._format_comments_post = None
        self._empty = None
        self.discriminator = None

        if value_as_string is not None:
            self.value_as_string = value_as_string
        if value is not None:
            self.value = value
        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if empty is not None:
            self.empty = empty

    @property
    def value_as_string(self):
        """Gets the value_as_string of this IPrimitiveType.  # noqa: E501


        :return: The value_as_string of this IPrimitiveType.  # noqa: E501
        :rtype: str
        """
        return self._value_as_string

    @value_as_string.setter
    def value_as_string(self, value_as_string):
        """Sets the value_as_string of this IPrimitiveType.


        :param value_as_string: The value_as_string of this IPrimitiveType.  # noqa: E501
        :type: str
        """

        self._value_as_string = value_as_string

    @property
    def value(self):
        """Gets the value of this IPrimitiveType.  # noqa: E501


        :return: The value of this IPrimitiveType.  # noqa: E501
        :rtype: object
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this IPrimitiveType.


        :param value: The value of this IPrimitiveType.  # noqa: E501
        :type: object
        """

        self._value = value

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this IPrimitiveType.  # noqa: E501


        :return: The format_comments_pre of this IPrimitiveType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this IPrimitiveType.


        :param format_comments_pre: The format_comments_pre of this IPrimitiveType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this IPrimitiveType.  # noqa: E501


        :return: The format_comments_post of this IPrimitiveType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this IPrimitiveType.


        :param format_comments_post: The format_comments_post of this IPrimitiveType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def empty(self):
        """Gets the empty of this IPrimitiveType.  # noqa: E501


        :return: The empty of this IPrimitiveType.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this IPrimitiveType.


        :param empty: The empty of this IPrimitiveType.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IPrimitiveType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
